/*
 * OS abstraction functions. Small functions should be defined
 * as "__inline" in os.h.
 */

#include "os.h"
/* following includes added for thread stuff from multithread.c 
 * Kill it when APR is in 
 */
//#include "ap_config.h"
//#include <process.h>
#include <assert.h>
#include <winsock2.h>

/*
 * Some code pulled from multithread.c. Keep it here until APR comes online...
 */
static int
map_rv(int rv)
{
    switch(rv)
    {
    case WAIT_OBJECT_0:
    case WAIT_ABANDONED:
        return(MULTI_OK);
    case WAIT_TIMEOUT:
        return(MULTI_TIMEOUT);
    case WAIT_FAILED:
        return(MULTI_ERR);
    default:
        assert(0);
    }

    assert(0);
    return(0);
}


/* ToDo:
 * Adapt the winnt mpm to use the APR thread functions.
 * The APR thread functions need to be tested...
 */
thread *
create_thread(void (thread_fn)(void *), void *thread_arg)
{
    int id;
    int rv;
    
    rv = _beginthreadex(NULL, 0, (LPTHREAD_START_ROUTINE)thread_fn,
            thread_arg, 0, &id);

    return((thread *)rv);
}


int
kill_thread(thread *thread_id)
{
    return(TerminateThread(thread_id, 1));
}


int
await_thread(thread *thread_id, int sec_to_wait)
{
    int rv;
    
    rv = WaitForSingleObject(thread_id, sec_to_wait*1000);
    
    return(map_rv(rv));
}

void
exit_thread(int status)
{
    _endthreadex(status);
}

void
free_thread(thread *thread_id)
{
    CloseHandle(thread_id);
}


